'''
  Creates a Lexicon <word><tab><sentiment score>
  from a .tsv or .TSV dataset that follows the
  format <polarity><tab><text> for 4-classes 
  sentiment polarity.

  Uses Python 2.7
'''

#Futures

#Generic
import math
#Other: nltk
from nltk.corpus import stopwords
from nltk.stem import WordNetLemmatizer
from nltk.corpus import wordnet
from nltk.tokenize import sent_tokenize, word_tokenize
import nltk


import gzip
import json
import csv
import re
import pandas as pd
import datetime

#Other: nltk
from nltk.corpus import stopwords


#Code
Words = {}


Lexicon_pb = {}
Lexicon_it = {}
Lexicon_scaled = {}
Threshold = 10
Gamma = 4
#1: very negative / 2: negative / 4: positive / 5: very positive
Polarity = ['1', '2', '4', '5']

Count_review = 0
Count_pos_review = 0
Count_neg_review = 0
Count_pos_word = 0
Count_neg_word = 0




Filter_Words=[]
main_words=[]
Neg_Words=[]


#CSV_path= 'F:\\MoviesReview.csv'
#fileSent = 'F:\\DataSetMovies3.tsv'

CSV_path= 'C:\\Users\\Sumaia\\Desktop\\New folder\\DataSets\\Final DataSet\\Yelp\\All Yelp\yelp-dataset\\RestaurantReview.csv'
fileSent = 'C:\\Users\\Sumaia\\Desktop\\New folder\\DataSets\\Final DataSet\\Yelp\\All Yelp\yelp-dataset\\RestaurantReview.tsv'




#===================== Start of Load Data Function ============================== #
#This function read Json file that contain the dataset and insert it to pandas DataFrame to  ease their use then copy the content of the DataFrame to excel file
def collect_dataset() :
    #Source_file_path ="F:\\Yarrrrrrrrrb\\PhD\\Thesis\\DataSets\\Final DataSet\\Amazon\\reviews_Movies_and_TV_5.json.gz"
    Source_file_path ="C:\\Users\\Sumaia\\Desktop\\New folder\\DataSets\\Final DataSet\\Yelp\\All Yelp\yelp-dataset\\yelp_academic_dataset_review.json"

    DataSetSize=1000000
    print (Source_file_path)
    loop=0 
    #open file    
    #file=open(Source_file_path,'r', encoding="utf8")  
    file=open(Source_file_path,'r', encoding="utf8")
  #======= This part to extract the data in json file to pandas dataframe work to ease the using then save it in excel file  
    #with open ( (CSV_path),'w') as csvfile:
    with open( fileSent,'wt', encoding="utf8") as out_file , open(CSV_path,'w', encoding="utf8") as csvfile:
         fieldnames = ['Word', 'SentimentScore']
         writer = csv.DictWriter(csvfile, fieldnames=fieldnames)        
         writer.writeheader()
         no=0
         p=0
         tsv_writer = csv.writer( out_file, delimiter='\t')
         for data in file:
            #print (loop)
            if(loop<=DataSetSize ): #loop how many rows u want to extract from the json file to put it in a dataframe    
                 xx=json.loads(data)
                 if (not ('review_id' in xx)):
                     ss='Noreview_id'
                 else:
                     ss= xx['review_id']
                 if (loop>=0):
                     if(xx['stars']==3):
                         p+=1                  
                     if(xx['stars']!=3):
                         tsv_writer.writerow([int(xx['stars']), xx['text']])
                         writer.writerow({'Word':   int(xx['stars']), 
                             'SentimentScore': xx['text']
                            })
                         
                         no+=1
                         
           
                 if(loop%100000==0):
                     print (loop)
            
            
                 loop=loop+1
                      
            else :
                 print("Done Loading DataSet")
                 file.close()
                 break

    print("Done Loading DataSet")
    print (' Reviews read ' + str (no))
    print (' Reviews ==3 ' + str (p))

    file.close()
    out_file.close()
    
    
#-------------------------------
collect_dataset()




arr=[]
def openfile_extractdata():
  
    df=pd.read_csv(CSV_path)
    print('Start loading Data....')
    print (df.shape[0])
    rows=0
    nanreview=0
   
    for i in range(df.shape[0]):  # df.shape give how many rows in the DataFrame
    #for i in  range(DataSetSize): 
      #if(i>=250000):
        #textreview=df.reviewText[i] 
        Non_Empty_review=0
        #check if there is a text review or not(nan) value
        if (len(str(df.SentimentScore[i]))==3) :
            #print (str(i) )
            #print (df.reviewText[i])
            if('nan' in str(df.SentimentScore[i])): #-- nan means the cell of the reviewText in this row is empty
                print ('OHO')
                Non_Empty_review=1
                nanreview= nanreview+1
                print('*************')
                          
        if ( Non_Empty_review==0): # There is a reviewText in the current row 
            arr.append( (df.SentimentScore[i],df.Word[i])) 
            rows=rows+1
     
    print("Done : " + str (rows) + " Reviews is read" )
    print("Done : " + str ( nanreview) + " Reviews is Empty" )
    
    
#=====================End Extract data ===============
    
openfile_extractdata() 
    
#-------------------------------------------------------------------------

#write lexicon to file
def print_lexicon():
    
    with open ('C:\\Users\\Sumaia\\Desktop\\Programming For Yelp\\Yelp - Restaurant\\Lexicon\\Case2LExicon10.csv','w') as csvfile2:
        
            fieldnames = ['Word', 'SentimentScore']
            writer = csv.DictWriter(csvfile2, fieldnames=fieldnames)        
            writer.writeheader()
            for w, s in Lexicon_scaled.items():
                            writer.writerow({'Word':    w, 
                             'SentimentScore': s
                            })
                                  
    
    csvfile2.close()
    #how many pos  and neg words
    pos_words=0
    neg_words=0
    for w, s in Lexicon_scaled.items():
        if (s>0):
            pos_words+=1
        elif (s<0):
            neg_words+=1

    print ( ' pos = '  + str (pos_words))
    print ( ' Neg = '  + str (neg_words))
    print ( ' total = '  + str (neg_words+pos_words))

	

#scaling
def build_lexicon():
  global Threshold
  highest_value_it, highest_value_pb = 0, 0
  for w,s in Lexicon_it.items():
    if abs(s) > abs(highest_value_it):
      highest_value_it = s
  for w,s in Lexicon_pb.items():
    if abs(s) > abs(highest_value_pb):
      highest_value_pb = s

  for wi in Lexicon_it:
    Lexicon_it[wi] = float(Lexicon_it[wi])/float(abs(highest_value_it))
  for wb in Lexicon_pb:
    Lexicon_pb[wb] = float(Lexicon_pb[wb])/float(abs(highest_value_pb))
  for w in Words: 
    if int(Words[w]['tot']) >= Threshold:
      sit, spb = Lexicon_it[w], Lexicon_pb[w]
      Lexicon_scaled[w] = (sit+spb)/2.0

#Compute the raw word score
def lexiconize():
  global threshold
  global Count_review
  global Count_pos_review
  global Count_neg_review
  global Count_pos_word
  global Count_neg_word

  temp_neg, temp_pos = 0, 0
  for w in Words:
    if Words[w]['tot'] >= Threshold:
      temp_pos += Words[w]['5']
      temp_pos += Words[w]['4']
      temp_neg += Words[w]['1']
      temp_neg += Words[w]['2']

  Count_pos_review = 1 if Count_pos_review == 0 else Count_pos_review
  Count_neg_review = 1 if Count_neg_review == 0 else Count_neg_review
  Count_pos_word = 1 if Count_pos_word == 0 else Count_pos_word
  Count_pos_word = 1 if Count_pos_word == 0 else Count_pos_word

  for w in Words:
    tot = int(Words[w]['tot'])
    tf5,tf4 = float(Words[w]['5']),float(Words[w]['4'])
    tf1,tf2 = float(Words[w]['1']), float(Words[w]['2'])
    if tot >= Threshold:
      ntf5,ntf4 = (tf5/float(Count_pos_review)*float(Count_review)), (tf4/float(Count_pos_review)*float(Count_review))
      ntf1,ntf2 = (tf1/float(Count_neg_review)*float(Count_review)), (tf2/float(Count_neg_review)*float(Count_review))
      wtf = (Gamma*ntf5+ntf4)-(Gamma*ntf1+ntf2)
      score_it = wtf * math.log(float(Count_review)/tot) 
      Lexicon_it[w] = score_it

      pw = float(tf5+tf4+tf2+tf1)
      pwpos, pwneg = ((Gamma*tf5+tf4)/float(temp_pos)+1)/float(len(Words)), ((Gamma*tf1+tf2)/float(temp_neg)+1)/float(len(Words))
      ppos, pneg = float(Count_pos_word)*pwpos/pw, float(Count_neg_word)*pwneg/pw
      score_pb = ppos-pneg
      Lexicon_pb[w] = score_pb
	
#create dict with w -> pos, neg, tot and remove stopwords
def dictionarize(tokens, polarity):
  global Count_pos_word
  global Count_neg_word

  for word in tokens:
    if word in Words:
      Words[word]['tot'] += 1.0
      if polarity == '5':
        Words[word]['5'] += 1.0/float(len(tokens))
        Count_pos_word += 1
      elif polarity == '4':
        Words[word]['4'] += 1.0/float(len(tokens))
        Count_pos_word += 1
      elif polarity == '1':
        Words[word]['1'] += 1.0/float(len(tokens)) 
        Count_neg_word += 1
      elif polarity == '2':
        Words[word]['2'] += 1.0/float(len(tokens)) 
        Count_neg_word += 1
    else:
      Words[word] = {}
      Words[word]['tot'] = 1.0
      if polarity == '5':
        Words[word]['5'] = 1.0/float(len(tokens))
        Words[word]['4'] = 0
        Words[word]['2'] = 0
        Words[word]['1'] = 0
        Count_pos_word += 1
      elif polarity == '4':
        Words[word]['4'] = 1.0/float(len(tokens))
        Words[word]['5'] = 0
        Words[word]['2'] = 0
        Words[word]['1'] = 0
        Count_pos_word += 1
      elif polarity == '2':
        Words[word]['2'] = 1.0/float(len(tokens))
        Words[word]['1'] = 0
        Words[word]['4'] = 0
        Words[word]['5'] = 0
        Count_neg_word += 1
      elif polarity == '1':
        Words[word]['1'] = 1.0/float(len(tokens))
        Words[word]['2'] = 0
        Words[word]['4'] = 0
        Words[word]['5'] = 0
        Count_neg_word += 1


#remove punctuation from token
def remove_punctuation(token):
    result = ''.join([c if c.isalpha() else ' ' if c == '.' else '' for c in token])
    return result.strip().lower().split(' ') if len(result)>1 else None



def parse_review(review):
  global Count_review
  global Count_pos_review
  global Count_neg_review

  #tokens = review.encode('utf-8', 'ignore').decode('utf-8').split('\t')
  #polarity, text  = tokens[0], tokens[1]
  text=review[0]
  polarity=str(review[1])

  if polarity == '4' or polarity == '5':
    Count_review += 1
    Count_pos_review += 1
  elif polarity == '1' or polarity == '2':
    Count_review += 1
    Count_neg_review += 1
  else:
    return

  words = []
  for w in text.split(' '):
    temp = remove_punctuation(w)
    if temp is not None:
      words.extend([w for w in temp if w != ''])
  #uniq_tokens = uniquify(words)
  
  stop_words=set (stopwords.words("english"))
              #
  clean_tokens=[]                     
  for i in range (len(words)):
                      if (words[i]  in Neg_Words):
                         clean_tokens.append(words[i])
                      elif (len( words[i])>2) and (words[i]  not in stop_words):
                          clean_tokens.append(words[i])
  #print(clean_tokens)
  if clean_tokens != '':
    dictionarize(clean_tokens, polarity)

def parse_reviews():
  #for review in file_tsv:
   # parse_review(review)
  Neg_Words=[]
  CSVPath3='C:\\Users\\Sumaia\\Desktop\\Programming For Yelp\\Yelp - Restaurant\\Lexicon\\NegationList.csv' 
  df3=pd.read_csv(CSVPath3) 
  for i in range (df3.shape[0]):
        if(i<df3.shape[0]):
            Neg_Words.append((df3.NWORDS[i])) 
  len(Neg_Words)
  
  
  training_data=[]
  size = 914186 #80 training 1496177 Reviews is read 54 Reviews is Empty
  for i in range(size): 
      training_data.append(arr[i])
  
  len ( training_data)
  print(training_data[0])
  counter=0
  print ('Start Preprocessing')
  
 
  for i in range(len( training_data)):  
 
             if (counter%100000==0):
                 currentDT = datetime.datetime.now()   
                 print (str(counter) + ' is processed at '+ str( currentDT)) 
        
             #print(training_data[i])
             parse_review( training_data[i])
             #print(Words)
            
             counter+=1



def main():
 
  global Threshold  
  collect_dataset()
  parse_reviews()  
  lexiconize()
  build_lexicon()
  print_lexicon()
  
  print (' No of Reviews  ' + str( Count_review) )
  print('No of Pos Reviews  ' + str(Count_pos_review))
  print('No of Neg Reviews ' + str(Count_neg_review))
  print ('No of pos words  ' +  str(Count_pos_word))
  print ('No of Neg words ' + str(Count_neg_word))
  print ('len Words  ' + str(len (Words)))
  print ('len lexicon  ' + str(  len(Lexicon_pb)))
  print (len(Lexicon_it))
  print( len( Lexicon_scaled))


if __name__ == '__main__':
	main()
