# -*- coding: utf-8 -*-
"""AspectBasedSentimentAnalysis_Yelp.ipynb

Automatically generated by Colaboratory.

Original file is located at
    https://colab.research.google.com/drive/1zH8QYEyWGelKuGUz3WZOHe8PUd89ccH5
"""

!pip3 install pandas
!pip3 install pycorenlp
!pip install stanfordnlp
#For connecting with Java StanfordCoreNLp
!echo "Downloading CoreNLP..."
!wget "http://nlp.stanford.edu/software/stanford-corenlp-full-2018-10-05.zip" -O corenlp.zip
!unzip corenlp.zip
!mv ./stanford-corenlp-full-2018-10-05 ./corenlp

#impoting Libraries
import pandas as pd
import gzip
import json
import nltk
import csv
import re
from nltk.corpus import stopwords
import numpy as np
import math
from nltk.stem import PorterStemmer
from nltk.stem import WordNetLemmatizer
from itertools import chain
from nltk.corpus import wordnet
from nltk.tokenize import sent_tokenize, word_tokenize
from pycorenlp import StanfordCoreNLP
import datetime
# Import stanfordnlp
import stanfordnlp
import os


os.environ["CORENLP_HOME"] = "./corenlp"

from stanfordnlp.server import CoreNLPClient

# Construct a CoreNLPClient with some basic annotators, a memory allocation of 20GB, and port number 9001
client = CoreNLPClient(annotators=['tokenize','ssplit', 'pos', 'lemma', 'ner'], memory='10G', endpoint='http://localhost:9001')
print(client)

# Start the background server and wait for some time
# Note that in practice this is totally optional, as by default the server will be started when the first annotation is performed
client.start()

# Print background processes and look for java
!ps -o pid,cmd | grep java

nltk.download('punkt')
nltk.download('stopwords')
nltk.download('wordnet')



import os
os.environ["CORENLP_HOME"] = "./corenlp"

from stanfordnlp.server import CoreNLPClient

# Construct a CoreNLPClient with some basic annotators, a memory allocation of 20GB, and port number 9001
client = CoreNLPClient(annotators=['tokenize','ssplit', 'pos', 'lemma', 'ner'], memory='20G', endpoint='http://localhost:9001')
print(client)

# Start the background server and wait for some time
# Note that in practice this is totally optional, as by default the server will be started when the first annotation is performed
client.start()

# Print background processes and look for java
!ps -o pid,cmd | grep java



noun_adj_pairs = []
adj_without_noun=[]
n_adj_pair=[]  
compar_super_noun=[]
compar_super_adj=[]
all_adj=[]
Phrases=[]
Complete_Phrase=[]
siz=0

#from pycorenlp import StanfordCoreNLP
#client = CoreNLPClient(annotators=['tokenize','ssplit', 'pos', 'ner'], memory='20G', endpoint='http://localhost:9001')

def remove_punctuation(token):
    result = ''.join([c if c.isalpha() else ' ' if c == '.' else '' for c in token])
    return result.strip().split(' ') if len(result)>1 else None


Aspect_array=[]
main_words=[]
Aspect_array5=[]  
Filter_Words=[]
main_array=[]
reviewerid=[]
productid=[]
Aspect_Rating=[]



#Skipped_words=['fabulous','fantastic','nice','stupid','goofy','wonderful','sure','certainly','old','believable','reseaonable','believably','likable','lovely','likeable','hilarious','cheerful','satire','containing', 'satire','satirical', 'awesome','crazy','enjoyable']

Skipped_words=['crispy', 'delicious', 'spicy', 'delicious', 'flavorful', 'creamy', 'flavourful', 'fruity', 'curly', 'crunchy', 'yummy', 'delicous', 'spicey', 'vinegary', 'eggy', 'bready', 'chocolatey', 'peppery', 'frizzy']
Shared_aspect=['time','year','day','people','guy','friend','work','job','bit','one','review','thing','part','place','way','he','she','we','they','it']   
#Aspect_array=[]
CSVPath1='/content/Final List_CoreTerms.csv'
df=pd.read_csv(CSVPath1) 
for i in range (df.shape[0]):
               Aspect_array.append(df.Word[i])

len(Aspect_array)

def processing_crazyletters(word):
    #print ('Start') 
    #print (word)
    woord=''
    
    #word='última'  åpnet  âme âges àgain âgée àcôté  øyet ørkenen  øyne ìndiebusinesses àcôté  ímuy ítems  çikolata çadéco àlacarte íbamos  çocukluunu ítens àlentrée àre ôte ýour
    #word='ýour' #          ôte ýour

    
    for c in word:
                   #print(c)
                   asc=ord(c)
                   #print (ord(c))
                   if (asc==233):
                        woord+='e'
                        
                   elif (asc==234):
                        woord+='e'
                   elif (asc==232):
                        woord+='e'
                   elif ((asc==228) | (asc==229) | (asc==226) | (asc==224)):
                        woord+='a'
                   elif (asc==225):
                        woord+='a'
                   elif (asc==231):
                        woord+='c'
                   elif ((asc==236)|(asc==238)|(asc==237)):
                        woord+='i'
                   elif (asc==252):
                        woord+='u'
                   elif (asc==250):
                        woord+='u'
                   elif (asc==253):
                        woord+='y'
                   elif (asc==246):
                        woord+='o'
                   elif ((asc==243) |(asc==244)|(asc==248)):
                        woord+='o'
                       
                   else:
                       woord+=c

    #print (woord)
    return (woord)

#-----------------------------------------    
  
#Blocking 
    
Full_Block_Dictionary=[{} for i in range(27)]

#Clear the list "تهيئه للخزن"
for i in range(27):
    Full_Block_Dictionary[i]['Word']=[]
    Full_Block_Dictionary[i]['SentimentScore']=[]
    
    

#*********** End of global variables*******************


#============================ Start building block ==============================


def blocking():
    global main_words
    special=0
    uniquewords=0
    for i in range(27):
        Full_Block_Dictionary[i]['Word']=[]
        Full_Block_Dictionary[i]['SentimentScore']=[]
    print('Start Blocking')
    for i in range(len (main_words)):
        word=str(main_words[i][0])
      
        first_letter=word[0]
        ascii_firstletter= ord(first_letter.upper())
        block_no= ascii_firstletter-65
        
        Flag=0
        new_word=''
        if   (block_no>=27) or (block_no<0)  :
           
            special=special+1
            #print ('# Special =  ' + str(special) + '  ' +main_words[i][0] + '  in block no '+str(block_no) )
            new_word= processing_crazyletters(main_words[i][0])
            #print (new_word)        
            
            first_letter=new_word[0]
            ascii_firstletter= ord(first_letter.upper())
            block_no= ascii_firstletter-65
            Flag=1
            
            

            
            
        if (Flag==1):
                    Full_Block_Dictionary[ block_no]['Word'].append(new_word)
        else:            
                    Full_Block_Dictionary[ block_no]['Word'].append(main_words[i][0])
        Full_Block_Dictionary[ block_no]['SentimentScore'].append(main_words[i][1])
        uniquewords=uniquewords+1
    print ('unique nouns = ' + str(uniquewords)) 
   


#============================ END building block ==============================+
    
#End blocking



print ('Start')
 main_words=[]

 CSVPath2='/content/Case2LExicon10.csv' 
 #df2=pd.read_csv(CSVPath2) 
 df2=pd.read_csv(CSVPath2, encoding='latin-1') 

 for i in range (df2.shape[0]):
        if(i<df2.shape[0]):
            main_words.append((df2.Word[i],df2.SentimentScore[i])) 
            
            
 blocking()

main_words

#Read the Aspect weight 
CSV_path4='/content/ThirdStasticalforaspectRanking.csv' 
df3=pd.read_csv(CSV_path4) 
df3.shape[0]
Aspect_details_array=[{} for i in range(27)]

#Clear the list 
for i in range(27):
                                     
        Aspect_details_array[i]['Word']= []
        Aspect_details_array[i]['Weight1']=[] #Normal tfid tf=noofoccurance/noofwords in review
        Aspect_details_array[i]['Weight2']=[] #modified tfidf (noofwordsin a class/no of all reviews)
        Aspect_details_array[i]['Weight3']=[] #modified tfidf (noofwordsin a class/no of  total reviews in a class)

Aspect_array5=[]   
for i in range (  df3.shape[0]  ):
    Aspect_array5.append((df3. Word[i],df3. Weight11[i],df3. Weight22[i],df3. Weight33[i]))

len(Aspect_array5)
Aspect_array5[1]



size=len(Aspect_array5)
for i in range(size) :
        word=Aspect_array5[i][0]         
        first_letter=word[0]
        ascii_firstletter= ord(first_letter.upper())
        block_no= ascii_firstletter-65
        special=0
        if   (block_no>=27) or (block_no<0)  :
            special=special+1
            print ('# Special =  ' + str(special) + '  ' +word + '  in block no '+str(block_no) )
       #initalization
        Aspect_details_array[block_no]['Word'].append(word)
        Aspect_details_array[block_no]['Weight1'].append(Aspect_array5[i][1])
        Aspect_details_array[block_no]['Weight2'].append(Aspect_array5[i][2])
        Aspect_details_array[block_no]['Weight3'].append(Aspect_array5[i][3])

Filter_Words=[]
global SentimentScore
def Sentiment_Score ():
    global Filter_Words
    global SentimentScore
    SentimentScore=0

    #print('***************************************')
    #print(' Filter Words in Sentiment Score : ' + str (len(Filter_Words)))
    #print (Filter_Words)
    SentScore=0
    no=0
    for word in Filter_Words: 
        #Here

      
        first_letter=str(word[0])
        asc=ord(first_letter)
        if (asc in [232,233,234,228,238,252,246,225,250,243,229,226,224,248,236,237,231,244,253]):
                
                 wrd=processing_crazyletters(word)
                 word=wrd
                 first_letter=str(word[0])
         
    
    
        ascii_firstletter= ord(first_letter.upper())
        block_no= ascii_firstletter-65
        ind=0
        wordscore=0
        #print ( word  + '  ' + str(block_no))
        if   ((block_no<27) and (block_no>=0))  :
         for w in  Full_Block_Dictionary[ block_no]['Word']:
           wordscore=0
           if (word==w):
               wordscore=Full_Block_Dictionary[ block_no]['SentimentScore'][ind]
               no+=1
               #print (w + '  :  ' + str(wordscore))
               break
           ind+=1
        #else : 
             #print ( word  + ' tyriuoi ' + str(block_no))
    
        SentScore+=wordscore  
        
    #print (' SentimentScoreInside = ' + str (SentScore))
    #print('#####################################################')
    SentimentScore=SentScore
    
        
    return(SentScore)



DataSetSize=200000
main_array=[]
def sentence_base_Preprocessing(content):
       global Phrases
       global Filter_Words
       global Complete_Phrase
       global main_array
       global Aspect_Rating

       ps = PorterStemmer()
       stop_words=set (stopwords.words("english"))
       tokenizer = nltk.data.load('tokenizers/punkt/english.pickle')
       lemmatizer = WordNetLemmatizer()   
       #print ('start Extraction')

       kkk=0
  
       Phrases=[]
       Complete_Phrase=[]
       #print('************************************************')
       #print (k)
       #print (content)
       kkk=kkk+1
       
      # print (kkk)
       if kkk<=DataSetSize  :
           review_text = content
          
           if((kkk%1000) ==0):
               currentDT = datetime.datetime.now() 
               print (str(kkk) + ' review is  is processed at '+ str( currentDT)) 

            
     
             
           
         
           split_words=[]
           pointer=0
           rr=[]
           new_text=''
#------------------------- This part is only for Yelp dataset
           
           flag_special=0
           #if("\xa9" in review_text ):
            #   print str( k) + ' **************************************************************************'
           if(("\xc3" in review_text ) or  ("\xc2" in review_text )):
                      # woord+=" "
                print ("YES") 
                flag_special=1
               
               
           if (flag_special==1) :
               
               woord=''
             
               for c in review_text:
                   
                   if c == "\xc3":
                       woord+='e'
                   elif c=="\xc2":
                       woord+=" "
                       
                   elif ((c=="\xa9") or (c=="\x97")  or (c=="\xc2")): 
                       woord+=" "
                  
                   elif c=="\xb1": 
                       woord+="n"
                   elif c=="\x8d": 
                       woord+="i"
                   elif c=="\x9e": 
                       woord+="y"
                   elif c=="\x9f":
                       woord+="B" 
                   elif c=="\xb0": 
                       woord+="o"
                   elif c=="\xb9": 
                       woord+="o"
                   elif c=="\xb6":
                       woord+="o"
                   elif c=="\xb4":
                       woord+="o"
                   elif c=="\xba":  
                       woord+="u"
                   elif c=="\xbb":
                       woord+="u"
                   elif c=="\xbc":
                       woord+="u"
                   elif c=="\xbd":
                       woord+="u"
                   elif c=="\xbf":
                       woord+="u"
                       
                   elif c=="\xb2":
                       woord+="u"
                   elif c=="\xb3":
                       woord+="u"
                   elif c=="\xb5":  
                       woord+="u"
                   elif c=="\xb7":
                       woord+="u"
                   elif c=="\xb8":
                       woord+="u"
                   elif c=="\xa3":
                       woord+="a"
                   elif c=="\xa4":
                       woord+="a"
                   elif c=="\xa5":
                       woord+="a"
                   elif c=="\x8a":
                       woord+="a"
                   elif c=="\xa1":
                       woord+="a"
                   elif c=="\xa0":
                       woord+="a"
                   elif c=="\x80":
                       woord+="a"
                   elif c=="\xaa": 
                       woord+="a"
                   elif c=="\xab": 
                       woord+="a"
                   elif c=="\xac": 
                       woord+="a"
                   elif c=="\xad": 
                       woord+="a"
                    
                   elif c=="\xa2": 
                       woord+="e"
                   elif c=="\xa6":
                       woord+="e"
                   elif c=="\xa7":
                       woord+="e"
                   elif c=="\xa8": 
                       woord+="e"
                   elif c=="\xae":
                       woord+="e"
                   elif c=="\x9c": 
                       woord+="e"
                   elif c=="\xaf":
                       woord+="e"
                   elif  c=="\x81":
                        woord+="e"
                   elif  c=="\x8c":
                        woord+="e"
                   elif  c=="\x8e":
                        woord+="i"
                       
                        
                   elif  c=="\x83":
                        woord+="a"
                        
                   elif  c=="\x84":
                        woord+="a"
                   elif  c=="\x85":
                        woord+="a"
                        
                   elif  c=="\x87":
                        woord+="c"
                        
                   elif  c=="\x88":
                        woord+="c"          
                   elif  c=="\x89":
                        woord+="c"
                        
                   elif  c=="\x96":
                        woord+="o"
                        
                   elif  c=="\x99":
                        woord+="u"
                   elif  c=="\x9a":
                        woord+="a"
                   elif  c=="\x91":
                        woord+="a"
                   elif  c=="\x92":
                        woord+="a"
                   elif  c=="\x93":
                        woord+="o"
                   elif  c=="\x94":
                        woord+="i"
                    
                       
                   else:
                       woord+=c
                 #print (' Before \n ' +  review_text)
               review_text=woord
              # review_text=woord.encode("utf-8")
               
              # review_text=woord.encode("utf-8")
                
               #---------------------------------------
               
           
           
           #------------------------ End The part that is only for Yelp dataset     

          #This part just for making sure that the full stop at the end of each sentence is seperated from the word
           for letter in  review_text :
              if( letter != '.') :
                 new_text= new_text + letter
              else:
                 new_text=new_text +' . '
                   
                      
           #Divide the review into sentences
           tokenized_sent=tokenizer.tokenize( new_text)
           previous_phrase=''  
           person=[]
 
           for sentence in tokenized_sent :
             
             
              
             tokenzied1= sentence           
               
             if (len(tokenzied1)>1):
                 #print (tokenzied1) #we call ner bcz we need to know people (person using NER : Name Entity Recogniaztion)
                 output = client.annotate(tokenzied1, properties={'annotators': 'depparse,ner','outputFormat': 'json'})  
  
                 #print ('len = ' + str (len(output)) + '   ' + str(len(output['sentences'])))
                 if (len(output['sentences'])>=1):
                   for sentence in output["sentences"]:
                   
                
                      for tokn in sentence['tokens']:
                              
                                       if(tokn['ner']=='PERSON') or (tokn['ner']=='MISC')or (tokn['ner']=='TITLE')or (tokn['ner']=='LOCATION'):
                                               #print('ooooooooooooooooh Yaaaaah ' + tokn['word'])
                                               person.append(tokn['word'])
              
                              
                 if (len(output['sentences'])>=1):
                  
                  t_previous=''
                  previous_word= ''
                  previous_modifier=''
                  previous_ind=0
                  phrase_full=''
                  for s in output['sentences']:
                    for t in s['enhancedDependencies']:  
                        #print ( t)
                     
                      #if (t['dep']=='amod') or   (t['dep']=='advmod')   or   (t['dep']=='nsubj') or   (t['dep']=='nsubjpass') or   (t['dep']=='xcomp') or   (t['dep']=='acomp') or (t['dep']=='neg') or (t['dep']=='conj')  :
                      if (t['dep']=='amod') or   (t['dep']=='advmod')  or   (t['dep']=='nmod') or   (t['dep']=='agent') or   (t['dep']=='dobj') or   (t['dep']=='nsubj') or   (t['dep']=='nsubjpass') or   (t['dep']=='pobj') or   (t['dep']=='xcomp') or (t['dep']=='neg')  or   (t['dep']=='case') or (t['dep']=='nmod:like')or (t['dep']=='dep')  :

                         if (len( t['governorGloss'])>2) and (t['governorGloss']  not in stop_words):

                         
                         
                           adding_word=(t['governorGloss'])
                           adjectve=t['dependentGloss']  
                            # governerGloss gives the noun - dependentGloss gives the adj
                           ind=t['dependent'] #Adjective position
                           flag=0
                           
                           for tokn in s['tokens']:
                         

                               if (tokn['index']==ind):# or (t['index']==ind2)):
                                 
                                       Phrases.append((adjectve+' '+adding_word))
                                        
                                    
                                       current_phrase1= adjectve+' '+adding_word
                                      
                                       flag=1
                                       if (previous_word==adding_word): 
                                           current_phrase= previous_modifier + ' ' +adjectve +' '+adding_word 
                                           previous_ind=1
                                       elif  (adjectve==previous_word):
                                           current_phrase= adding_word + ' '+ previous_modifier + ' ' +adjectve
                                           previous_ind=1
                                       else:
                                           previous_ind=0


                                           


                           
                           t_previous=t['dep']
                           previous_word= adding_word
                           previous_modifier=adjectve
                           x=0 # (previous_phrase!='') means the first phrase
                           if   (previous_ind==0)  and  ((previous_phrase!='N') and  (previous_phrase!='')):
                               Complete_Phrase.append( previous_phrase)
                           elif ((previous_ind==1) ):
                                                            
                               Complete_Phrase.append(current_phrase) 
                               x=1
                               previous_ind=0
                        
                           if(x==0):                  
                               previous_phrase= adjectve+' '+adding_word
                              # print ('Previous*####  :  ' +previous_phrase + '  ' + str(previous_ind))
                              # previous_ind=0
                           else:
                               previous_phrase='N' #remove the previous one bcz it is included incurrent phrase
                           #print(len(s['tokens']))
                           first_letter=adding_word[0]
                           ascii_firstletter= ord(first_letter.upper())
                           block_no= ascii_firstletter-65
                           #if   (block_no>=27) or (block_no<0)  :
                                        #print ('# Special =  '  +adding_word + '  in block no '+str(block_no) )



               
           if ((previous_ind==0) )  and  ((previous_phrase!='N')): #to add last phrase
               Complete_Phrase.append( previous_phrase)

           #print(Complete_Phrase)
          
           stop_words=set (stopwords.words("english"))
              
           new_phrase=[] 
           for phrase in (Complete_Phrase):
              
               tokenzied9=nltk.word_tokenize(phrase)
               Phrase0=''
               flag=0

               for i in range (len (tokenzied9)):
                   flag=0
                   if (tokenzied9[i]  in person) :
                       flag=1
                       break
               
               for i in range (len (tokenzied9)):                            
                                 Phrase0+=tokenzied9[i]+ ' ' 
               if (flag==1):
                        new_phrase.append((Phrase0,1))
               else:                         
                        new_phrase.append((Phrase0,0) )
                       
               new_phrase.append((Phrase0,0) )
                  
                  

                      
                       
           #print(new_phrase)
           Second_new_phrase=[]    
           temp=[]
           for phrase in (new_phrase):
              
               tokenzied9=nltk.word_tokenize(phrase[0])
               Phrase0=''
               list=[]
               exception= ['very','not','just','he','she','we','they','too','it','no','nor']

               for i in range (len (tokenzied9)):
                   if (tokenzied9[i].lower()  not in stop_words) or (tokenzied9[i].lower()  in exception)  :
                       list.append(tokenzied9[i])
                       
               
               if (len(list)>1): #more than word
                  for i in range (len (list)):
                    Phrase0+=list[i]+ ' '
                  if (Phrase0 not in temp) :
                    
                    Second_new_phrase.append(( Phrase0,phrase[1]))
                    temp.append(Phrase0)
           
           #print(Second_new_phrase)           

           third_new_phrase=[]    
           temp=[]
           i=0
           container=[]
           tokenzied2=''
           while(i < (len(Second_new_phrase))):
           #for i in range(len(Second_new_phrase)):
              
              tokenzied1=nltk.word_tokenize(Second_new_phrase[i][0])
              if (i<(len(Second_new_phrase))-1):
                tokenzied2=nltk.word_tokenize(Second_new_phrase[i+1][0])
              new_ph=''
              pp=0
              if(Second_new_phrase[i][1]==1) and (len(tokenzied2)>0):
                if (tokenzied1[len(tokenzied1)-1]==tokenzied2[0]):
                      new_ph=  Second_new_phrase[i][0]  +' '
                      for i5 in range(len( tokenzied2)):
                               if(i5>0):
                                 new_ph+=  tokenzied2[i5]  +' '
                      third_new_phrase.append((new_ph,1))
                      pp=1

              f=0                 
              if(pp==0):                
               ind=0
               for j in range (len (tokenzied1)):
                  for k in range (len (tokenzied2)):
                    if (tokenzied1[j]==tokenzied2[k]):
                      ind+=1
               ind2=0
               for j in range (len (tokenzied2)):
                  for k in range (len (tokenzied1)):
                    if (tokenzied2[j]==tokenzied1[k]):
                      ind2+=1
              
               if (ind==len (tokenzied1)) or (ind2==len (tokenzied2)):
                
                       f=1
                       #all the words in the next phrase
                       if(len (tokenzied1)>len (tokenzied2)):
                          third_new_phrase.append(Second_new_phrase[i])
                          container.append(Second_new_phrase[i][0])
                       else:
                          if (i<(len(Second_new_phrase))-1):
                             third_new_phrase.append(Second_new_phrase[i+1]) 
                             container.append(Second_new_phrase[i][0])

               if(f==0):
                   third_new_phrase.append(Second_new_phrase[i]) 
                   container.append(Second_new_phrase[i][0])

               
               elif (i==len(Second_new_phrase)-1):
                   third_new_phrase.append(Second_new_phrase[i])
                   container.append(Second_new_phrase[i][0])


              if(f==1) or(pp==1):
                i=i+2
              else : 
                i=i+1
              
           #print(third_new_phrase) 

           new_phrase=[]            #
          
           for phrase in (third_new_phrase):
               #print (phrase)
               tokenzied9=nltk.word_tokenize(phrase[0])
               Phrase0=''
               flag=0
               if (phrase[1]==1) or (tokenzied9[0][0].isupper()):
                  #flag=1
                   new_phrase.append((phrase[0],phrase[1]) )
               else:
                for i in range (len (tokenzied9)):
                   wword=tokenzied9[i].lower()
                   lema_word= lemmatizer.lemmatize(wword)
                   if (wword  in Aspect_array) or ( lema_word in Aspect_array) or (wword  in Shared_aspect) or ( lema_word in Shared_aspect)  :
                       flag=1
                       break
               if (flag==1):
                        w=0
                        for i in range (len (tokenzied9)):
                                Phrase0+=tokenzied9[i].lower()+ ' '
                                w+=1
                                                                                     
                        if(w>1):
                            new_phrase.append((Phrase0,phrase[1]) )


                       
           #print(new_phrase)
           Last_Phrase=[]
           #Calculating phrase_score (phrase , sentimentScore)
           for final_phrase in new_phrase:
            Filter_Words=[]
            Chosen_Aspect=''
            tokenzied0=nltk.word_tokenize(final_phrase[0])
            if (final_phrase[1]==1) or (tokenzied0[0][0].isupper()):
               for i in range(len(tokenzied0)):
                  if(i>0):
                    Filter_Words.append(tokenzied0[i])
            
            else:
              for worrd in ((tokenzied0)):
                   lema_word= lemmatizer.lemmatize(worrd)
                   flg=0
                   aspect=''
                   if (worrd  in Aspect_array) or ( lema_word in Aspect_array) or (worrd  in Shared_aspect) or ( lema_word in Shared_aspect)  :
                      if (worrd not in Skipped_words):

                          flg=1
                          aspect=worrd

                   if (flg==1 ):
                      for worrd in ((tokenzied0)):
                          if (worrd!=aspect):
                             Filter_Words.append(worrd)


                      
              #------------------------
         



            #print(Filter_Words) 
            for worrd in ((tokenzied0)):
                   lema_word= lemmatizer.lemmatize(worrd)
                   #if (worrd  in Vocabulary_Array) :#or ( lema_word in Aspect_array) or (worrd  in Shared_aspect) or ( lema_word in Shared_aspect)  :
                   if (worrd  in Aspect_array) or ( lema_word in Aspect_array) or (worrd  in Shared_aspect) or ( lema_word in Shared_aspect)  :                    
                      if worrd not in ['he','she','we','they','it']:
                        Chosen_Aspect=worrd
            AspectWeight=0
            if (Chosen_Aspect != ''):
              #----------------------- bring the aspect weight
              first_letter=str(Chosen_Aspect[0])
              #print (first_letter)

              ascii_firstletter= ord(first_letter.upper())
              block_no= ascii_firstletter-65
              #print(block_no)                            
              zz=-1
              
              if   ((block_no<27) and (block_no>=0))  :
                    for w in  Aspect_details_array[ block_no]['Word']:
                      zz=zz+1
                      if (Chosen_Aspect==w):
                          
                            AspectWeight=Aspect_details_array[ block_no]['Weight2'][zz]
                      
              #------------------------
       

              #--------------------------
            score= Sentiment_Score () 
            #print (score)
            if ((Chosen_Aspect !='') and (AspectWeight!=0)):
              score=score*AspectWeight
            
#----------------------------------      
              flag_aspect=0
              for p in range(len(Aspect_Rating)):
                if Aspect_Rating[p][0]==Chosen_Aspect:
                  flag_aspect=1   
                                
                  aspect_occurance=Aspect_Rating[p][3]
                  aspect_score=Aspect_Rating[p][2]
                    
                  Aspect_Rating[p][3] =  aspect_occurance+1            #now new assignment will be valid
                  Aspect_Rating[p][2] = aspect_score+score
                 
                  break
              if flag_aspect==0 : #Not added before the aspect 
                            Aspect_Rating.append([Chosen_Aspect,AspectWeight,score,1])
              


#-------------------------------




            Last_Phrase.append((final_phrase[0],score))
            

             
           #print(Last_Phrase)  
           final_score=0
           for ph in Last_Phrase:
              final_score+=ph[1]
           second_final_score=0
           if(len(Last_Phrase)>0):
              second_final_score=  final_score/len(Last_Phrase)
           else:
              second_final_score=  final_score

           #print(' Final Score ' + str(final_score))
           #print(' Short Final Score ' + str(second_final_score))
           main_array.append((content[1],second_final_score,final_score))


       return(final_score) 

     